//+------------------------------------------------------------------+
//|                                                3Auto_Targets.mq4 |
//+------------------------------------------------------------------+

#property copyright " OlegVS"
#property link      " olegvs2003@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Aqua
#property indicator_color2 Gold
#property indicator_color3 Magenta
#property indicator_color4 Blue
#property indicator_color5 Red
#property indicator_color6 Lime
#property indicator_color7 Red

extern int    SnakeRange   = 3; 
extern int    FilterPeriod = 21; 
extern double MartFiltr    = 2;
extern int    PriceConst   = 6;
extern double sd           = 15;
extern int    Depth        = 30;
extern int    Deviation    = 5;
extern int    Backstep     = 3;
extern int    kk           = 3;   
extern int    mBar         = 500;

double Bars_ = 200;
string poz = "";
bool ft = true;

//+------------------------------------------------------------------+

double BuffT1[],BuffT2[],BuffT3[],BuffFan[],BuffDream[],BuffStart[],BuffStop[];
int shift,i,zzbar,pr,j;
double Target1,Target2,Target3,Fantasy,Dream,Start,Stop,PointA,PointB,PointC,zz,zzs,m,n,k,p,zzold,spred;

//+------------------------------------------------------------------+

int init(){
   SetIndexStyle(0, DRAW_LINE, STYLE_DASH);
   SetIndexBuffer(0, BuffT1);
   SetIndexStyle(1, DRAW_LINE, STYLE_DASH);
   SetIndexBuffer(1, BuffT2);
   SetIndexStyle(2, DRAW_LINE, STYLE_DASH);
   SetIndexBuffer(2, BuffT3);
   SetIndexStyle(3, DRAW_LINE, STYLE_DASH);
   SetIndexBuffer(3, BuffFan);
   SetIndexStyle(4, DRAW_LINE, STYLE_DASH);
   SetIndexBuffer(4, BuffDream);   
   SetIndexStyle(5, DRAW_LINE, EMPTY,2);
   SetIndexBuffer(5, BuffStart);
   SetIndexStyle(6, DRAW_LINE, EMPTY,2);
   SetIndexBuffer(6, BuffStop);      
   spred=MarketInfo(Symbol(),MODE_SPREAD); 
if(Point>0.0002) pr=2; else pr=4;  
   Comment("");  
   return(0);}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
//----
   return(0);
  }   
//====================================================================   
int start()
{
//+------------------------------------------------------------------+

  if (mBar < 1) Bars_ = Bars; else Bars_ = mBar;

 for (shift =1;shift <=mBar ;shift ++)
   { 
      zzs=iCustom(NULL, 0, "iZigZag-T01",SnakeRange,FilterPeriod,MartFiltr,PriceConst,sd,Depth,Deviation,Backstep,kk,mBar,0,shift);
  if (zzs == 0 && ft == False) p=0;
  if((zzs != 0 || ft) && p==0) 
   {  p=1;PointC=0;PointB=0;PointA=0;k=0;n=0;m=0; 
 for (i=0;i<=mBar ;i++)
   { 
      zz=iCustom(NULL, 0, "iZigZag-T01",SnakeRange,FilterPeriod,MartFiltr,PriceConst,sd,Depth,Deviation,Backstep,kk,mBar,0,i);
  if (zz != 0 && k == 0) { k=1;PointC=zz;zzbar=i;} 
  if (zz != 0 && zz != PointC && k == 1 && n == 0) { n=1;PointB=zz;} 
  if (zz != 0 && zz != PointC && zz != PointB && k == 1 && n == 1 && m == 0) { m=1;PointA=zz;} 
  if (zz == 0 && PointC != 0 && PointB != 0 && PointA != 0 && PointC != PointB && PointB != PointA && PointA != PointC && k+n+m==3) break;
   }
   } 
      Target1=NormalizeDouble((PointB-PointA)*0.618+PointC,pr);
      Target2=NormalizeDouble((PointB-PointA+PointC),pr);
      Target3=NormalizeDouble((PointB-PointA)*1.618+PointC,pr);
      Fantasy=NormalizeDouble((PointB-PointA)*2.618+PointC,pr);
      Dream=NormalizeDouble((PointB-PointA)*4.618+PointC,pr);
      
  if (PointB<PointC)
  {
      Start= NormalizeDouble((PointB-PointA)*0.318+PointC,4)-spred*Point;
      Stop=PointC+2*(Ask-Bid);
  }
  if (PointB>PointC)
  {
      Start= NormalizeDouble((PointB-PointA)*0.318+PointC,4)+spred*Point;
      Stop=PointC-2*(Ask-Bid);}     
  } 
/*  
      ObjectSetText("Stop_txt","Stop="+Stop,10,"Arial",White);
  if (ObjectFind("Stop_txt")!=-1) ObjectMove("Stop_txt",0,Time[0],Stop+10*Point);
else
  {
      ObjectCreate("Stop_txt",OBJ_TEXT,0,Time[0],Stop+10*Point,0,0,0,0);
      ObjectSet("Stop_txt",OBJPROP_COLOR,White);  
  }            
      ObjectSetText("Start_txt","Start="+Start,10,"Arial",White);
*/      
  
 for (j=zzbar+10;j>=0;j--)
  {
      BuffT1[j]=Target1;BuffT2[j]=Target2;BuffT3[j]=Target3;BuffFan[j]=Fantasy;BuffDream[j]=Dream;BuffStart[j]=Start;BuffStop[j]=Stop;
  }     

  if (PointC != 0 && PointC>Start && Bid>Start) poz="SellStop for Target-1";
  if (PointC != 0 && PointC<Start && Ask<Start) poz="BuyStop for Target-1";
  if((PointC != 0 && PointC>Start && Close[0]<Start) || (PointC != 0 && PointC<Start && Close[0]>Start)) poz="No Trade";
  if (zzs != 0 || ft) 
 { 
Comment("\n","  ComaA=",PointA,"  ComaB=",PointB,"  ComaC=",PointC,
        "\n","  StartPrice=",Start,"  Position= ",poz);ft=false;} 
  return(0);}