//+------------------------------------------------------------------+
//|                                                   ZZOVER-T01.mq4 |
//|                        Copyright  2007, HomeSoft - Tartan Corp. |
//|                                              spiky@transkeino.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, HomeSoft - Tartan Corp."
#property link      "spiky@transkeino.ru"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Gold
#property indicator_color3 Red
#property indicator_color4 Red

extern int    SnakeRange   = 3; 
extern int    FilterPeriod = 21; 
extern double MartFiltr    = 2;
extern int    PriceConst   = 6;
extern double sd           = 15;
extern int    Depth        = 20;
extern int    Deviation    = 5;
extern int    Backstep     = 3;
extern int    mBar         = 500;

double SelBuff[0],BuyBuff[0],SSigBuff[0],BSigBuff[0],strone,strnul,zzstop,stop,zz,zzold,UrUp,UrDn,ds,db;
int shift,zzbar,zzbold,i,k,s,b;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,SelBuff);
   SetIndexStyle(0,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(0,242);
      
   SetIndexBuffer(1,BuyBuff);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(1,241); 
   
   SetIndexBuffer(2,BSigBuff);
   SetIndexStyle(2,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(2,159);   
   
   SetIndexBuffer(3,SSigBuff);
   SetIndexStyle(3,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(3,159);   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//    if (Period()!=1440) {Comment("\n","        D1");return(0);}   
   
   int    counted_bars=IndicatorCounted();
//----
    for(shift=Bars-1; shift>=0; shift--) 
    {   k=0;
    for(i=shift+2;i<=mBar;i++)
    {
        zz=iCustom(NULL,0,"ZigZagS",Depth,Deviation,Backstep,mBar,0,i);
    if (zz!=0 && k<2) k=k+1;
    if (k==2) {zzold=zz;zzbold=i;break;} 
    }   
        zzstop=iCustom(NULL,0,"ZigZagS",Depth,Deviation,Backstep,mBar,0,shift+1);
    if (zzstop!=0 && zzstop!=stop) {stop=zzstop;zzbar=shift;}     
        strone=iCustom(NULL,0,"SSRC",SnakeRange,FilterPeriod,MartFiltr,PriceConst,0,shift+1);
        strnul=iCustom(NULL,0,"SSRC",SnakeRange,FilterPeriod,MartFiltr,PriceConst,0,shift);
        
    if (strone>strnul && strnul<strone && s==0 && stop>=High[zzbar] && High[shift]<stop && (zzold>=stop || ((stop-Close[shift])/Point)>sd) && Close[shift]<Open[shift]) 
       {s=1;b=0;SelBuff[shift]=High[shift]+3*sd*Point;UrDn=High[shift]-sd*Point;} else SelBuff[shift]=0;
    if (strone<strnul && strnul>strone && b==0 && stop<=Low[zzbar] && Low[shift]>stop && (zzold<=stop || ((Close[shift]-stop)/Point)>sd) && Close[shift]>Open[shift]) 
       {b=1;s=0;BuyBuff[shift]= Low[shift]-3*sd*Point;UrUp=Low[shift]+sd*Point;} else BuyBuff[shift]=0;  
       
    if (SelBuff[shift]!=0) SSigBuff[shift]=UrDn; else SSigBuff[shift]=0;
    if (BuyBuff[shift]!=0) BSigBuff[shift]=UrUp; else BSigBuff[shift]=0;
          
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+